<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      :inline="true"
      v-show="showSearch"
      label-width="68px"
    >
      <div class="query-box">
        <div class="query-box__left">
          <el-form-item label="" prop="winName">
            <el-input
              v-model="queryParams.winName"
              placeholder="请输入窗口名称"
              clearable
              size="small"
              @keyup.enter.native="handleQuery"
            />
          </el-form-item>
          <el-form-item>
            <el-button
              type="primary"
              icon="el-icon-search"
              size="mini"
              @click="handleQuery"
              >搜索</el-button
            >
            <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
              >重置</el-button
            >
            <el-button
              type="primary"
              plain
              icon="el-icon-plus"
              size="mini"
              @click="handleAdd"
              v-hasPermi="['inventory:SystemWin:add']"
              >新增</el-button
            >
            <el-button
              type="warning"
              plain
              icon="el-icon-download"
              size="mini"
              :loading="exportLoading"
              @click="handleExport"
              v-hasPermi="['inventory:SystemWin:export']"
              >导出</el-button
            >
          </el-form-item>
        </div>
      </div>
    </el-form>

    <!-- <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['inventory:SystemWin:add']"
          >新增</el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['inventory:SystemWin:export']"
          >导出</el-button
        >
      </el-col>
      <right-toolbar
        :showSearch.sync="showSearch"
        @queryTable="getList"
      ></right-toolbar>
    </el-row> -->

    <el-table
      v-loading="loading"
      size="mini"
      :data="SystemWinList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column type="index" width="55" align="center" label="序号" />
      <el-table-column label="窗口名称" align="center" prop="winName" />
      <el-table-column label="网卡地址" align="center" prop="uuid"/>
      <el-table-column label="计算机名称" align="center" prop="computerName" />
      <el-table-column label="修改时间" align="center" prop="updateTime" />
      <el-table-column label="修改人姓名" align="center" prop="updateBy" />
      <el-table-column
        label="操作"
        align="center"
        width="180"
        class-name="small-padding fixed-width"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="primary"
            style="width: 40px"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['inventory:SystemWin:edit']"
            >修改</el-button
          >
          <el-button
            size="mini"
            type="primary"
            style="width: 40px"
            @click="handleDelete(scope.row)"
            v-hasPermi="['inventory:SystemWin:remove']"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改窗口管理对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="110px">
        <el-form-item label="窗口名称" prop="winName">
          <el-input v-model="form.winName" placeholder="请输入窗口名称" />
        </el-form-item>
        <el-form-item label="网卡标识" :required="true">
          <el-input
            v-model="form.uuid"
            placeholder="请输入网卡标识"
            style="width: 80%"
            disabled
            id="T6"
          />
          <el-button type="primary" style="margin-left:10px" @click="getUUID" :loading="bloading">点击获取</el-button>
        </el-form-item>
        <el-form-item label="计算机名称" prop="computerName">
          <el-input
            v-model="form.computerName"
            placeholder="请输入计算机名称"
          />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script></script>
<script>
import {
  listSystemWin,
  getSystemWin,
  delSystemWin,
  addSystemWin,
  updateSystemWin,
  exportSystemWin,
  uUID,
} from "@/api/inventory/SystemWin";

// import "../../../assets/js/LodopFuncs";
import { getLodop } from "@/assets/js/LodopFuncs";

var LODOP; //声明为全局变量
export default {
  name: "SystemWin",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 窗口管理表格数据
      SystemWinList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        winName: null,
        computerName: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        winName: [{ required: true, message:'请输入窗口名称', trigger: 'blur'}],
        computerName: [{ required: true, message:'请输入计算机名称', trigger: 'blur'}],
      },
      bloading: false
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询窗口管理列表 */
    getList() {
      this.loading = true;
      listSystemWin(this.queryParams).then((response) => {
        this.SystemWinList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        winName: null,
        uuid: null,
        computerName: null,
        createTime: null,
        updateTime: null,
        updateBy: null,
        createBy: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加窗口管理";
    },
    getUUID() {
      // uUID().then((res) => {
      //   // //console.log(res, "2323");
      //   this.form.uuid = res.msg;
      // });
      this.bloading = true
      this.getSystemInfo(
        "NetworkAdapter.1.PhysicalAddress",
        document.getElementById("T6")
      );
    },

    getSystemInfo(strINFOType, oResultOB) {
      LODOP = getLodop();
      if (LODOP.CVERSION)
      CLODOP.On_Return = function (TaskID, Value) {
        if (oResultOB) oResultOB.value = Value;
      };
      var strResult = LODOP.GET_SYSTEM_INFO(strINFOType)
      if (strResult) {
        var Result = LODOP.Result;
        if (Result) {
          this.form.uuid = Result.split('=')[1];
        }
      } else {
        this.$message.warning('获取失败，请重试')
      }
      this.bloading = false
    },

    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getSystemWin(id).then((response) => {
        this.form = response.data;
        this.open = true;
        this.title = "修改窗口管理";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          this.form.uuid = document.getElementById("T6").value, this.form
          if (!this.form.uuid) {
            return this.msgError('请点击获取网卡标识')
          }
          if (this.form.id != null) {
            updateSystemWin(this.form).then((response) => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addSystemWin(this.form).then((response) => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm("确定需要删除选中数据吗？", "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(function () {
          return delSystemWin(ids);
        })
        .then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm("是否确认导出所有窗口管理数据项?", "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          this.exportLoading = true;
          return exportSystemWin(queryParams);
        })
        .then((response) => {
          this.download(response.msg);
          this.exportLoading = false;
        })
        .catch(() => {});
    },
  },
};
</script>